/* Utils.c generated by valac 0.38.10, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;



gboolean display_utils_has_touchscreen (void);
GType display_monitor_get_type (void) G_GNUC_CONST;
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
gdouble* display_monitor_mode_get_supported_scales (DisplayMonitorMode* self, int* result_length1);
static gboolean _vala_double_array_contains (gdouble * stack, int stack_length, gdouble needle);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
gdouble display_monitor_get_max_scale (DisplayMonitor* self);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


gboolean display_utils_has_touchscreen (void) {
	gboolean result = FALSE;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	_tmp0_ = gdk_display_get_default ();
	display = _tmp0_;
	_tmp1_ = display;
	if (_tmp1_ != NULL) {
		GdkDeviceManager* manager = NULL;
		GdkDisplay* _tmp2_;
		GdkDeviceManager* _tmp3_;
		GdkDeviceManager* _tmp4_;
		GList* devices = NULL;
		GdkDeviceManager* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
		_tmp2_ = display;
		_tmp3_ = gdk_display_get_device_manager (_tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		manager = _tmp4_;
		_tmp5_ = manager;
		_tmp6_ = gdk_device_manager_list_devices (_tmp5_, GDK_DEVICE_TYPE_SLAVE);
		devices = _tmp6_;
		_tmp7_ = devices;
		{
			GList* device_collection = NULL;
			GList* device_it = NULL;
			device_collection = _tmp7_;
			for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
				GdkDevice* device = NULL;
				device = (GdkDevice*) device_it->data;
				{
					GdkDevice* _tmp8_;
					GdkInputSource _tmp9_;
					GdkInputSource _tmp10_;
					_tmp8_ = device;
					g_object_get (_tmp8_, "input-source", &_tmp9_, NULL);
					_tmp10_ = _tmp9_;
					if (_tmp10_ == GDK_SOURCE_TOUCHSCREEN) {
						result = TRUE;
						_g_list_free0 (devices);
						_g_object_unref0 (manager);
						return result;
					}
				}
			}
		}
		_g_list_free0 (devices);
		_g_object_unref0 (manager);
	}
	result = FALSE;
	return result;
}


static gboolean _vala_double_array_contains (gdouble * stack, int stack_length, gdouble needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}


GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors) {
	GeeLinkedList* result = NULL;
	GeeLinkedList* common_modes = NULL;
	GeeLinkedList* _tmp0_;
	gdouble min_scale = 0.0;
	GeeLinkedList* _tmp1_;
	gdouble _tmp2_;
	gboolean first_monitor = FALSE;
	g_return_val_if_fail (monitors != NULL, NULL);
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	common_modes = _tmp0_;
	_tmp1_ = monitors;
	_tmp2_ = display_utils_get_min_compatible_scale (_tmp1_);
	min_scale = _tmp2_;
	first_monitor = TRUE;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp3_;
		GeeLinkedList* _tmp4_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _monitor_index = 0;
		_tmp3_ = monitors;
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_monitor_list = _tmp4_;
		_tmp5_ = _monitor_list;
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
		_tmp7_ = _tmp6_;
		_monitor_size = _tmp7_;
		_monitor_index = -1;
		while (TRUE) {
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			gboolean _tmp14_;
			_tmp8_ = _monitor_index;
			_monitor_index = _tmp8_ + 1;
			_tmp9_ = _monitor_index;
			_tmp10_ = _monitor_size;
			if (!(_tmp9_ < _tmp10_)) {
				break;
			}
			_tmp11_ = _monitor_list;
			_tmp12_ = _monitor_index;
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _tmp12_);
			monitor = (DisplayMonitor*) _tmp13_;
			_tmp14_ = first_monitor;
			if (_tmp14_) {
				{
					GeeLinkedList* _mode_list = NULL;
					DisplayMonitor* _tmp15_;
					GeeLinkedList* _tmp16_;
					GeeLinkedList* _tmp17_;
					GeeLinkedList* _tmp18_;
					gint _mode_size = 0;
					GeeLinkedList* _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
					gint _mode_index = 0;
					_tmp15_ = monitor;
					_tmp16_ = display_monitor_get_modes (_tmp15_);
					_tmp17_ = _tmp16_;
					_tmp18_ = _g_object_ref0 (_tmp17_);
					_mode_list = _tmp18_;
					_tmp19_ = _mode_list;
					_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
					_tmp21_ = _tmp20_;
					_mode_size = _tmp21_;
					_mode_index = -1;
					while (TRUE) {
						gint _tmp22_;
						gint _tmp23_;
						gint _tmp24_;
						DisplayMonitorMode* mode = NULL;
						GeeLinkedList* _tmp25_;
						gint _tmp26_;
						gpointer _tmp27_;
						gdouble _tmp28_;
						DisplayMonitorMode* _tmp29_;
						gdouble* _tmp30_;
						gint _tmp30__length1;
						gdouble* _tmp31_;
						gint _tmp31__length1;
						_tmp22_ = _mode_index;
						_mode_index = _tmp22_ + 1;
						_tmp23_ = _mode_index;
						_tmp24_ = _mode_size;
						if (!(_tmp23_ < _tmp24_)) {
							break;
						}
						_tmp25_ = _mode_list;
						_tmp26_ = _mode_index;
						_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, _tmp26_);
						mode = (DisplayMonitorMode*) _tmp27_;
						_tmp28_ = min_scale;
						_tmp29_ = mode;
						_tmp30_ = display_monitor_mode_get_supported_scales (_tmp29_, &_tmp30__length1);
						_tmp31_ = _tmp30_;
						_tmp31__length1 = _tmp30__length1;
						if (_vala_double_array_contains (_tmp31_, _tmp31__length1, _tmp28_)) {
							GeeLinkedList* _tmp32_;
							DisplayMonitorMode* _tmp33_;
							_tmp32_ = common_modes;
							_tmp33_ = mode;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
						}
						_g_object_unref0 (mode);
					}
					_g_object_unref0 (_mode_list);
				}
				first_monitor = FALSE;
			} else {
				GeeLinkedList* to_remove = NULL;
				GeeLinkedList* _tmp34_;
				GeeLinkedList* _tmp75_;
				GeeLinkedList* _tmp76_;
				_tmp34_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				to_remove = _tmp34_;
				{
					GeeLinkedList* _mode_to_check_list = NULL;
					GeeLinkedList* _tmp35_;
					GeeLinkedList* _tmp36_;
					gint _mode_to_check_size = 0;
					GeeLinkedList* _tmp37_;
					gint _tmp38_;
					gint _tmp39_;
					gint _mode_to_check_index = 0;
					_tmp35_ = common_modes;
					_tmp36_ = _g_object_ref0 (_tmp35_);
					_mode_to_check_list = _tmp36_;
					_tmp37_ = _mode_to_check_list;
					_tmp38_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp37_);
					_tmp39_ = _tmp38_;
					_mode_to_check_size = _tmp39_;
					_mode_to_check_index = -1;
					while (TRUE) {
						gint _tmp40_;
						gint _tmp41_;
						gint _tmp42_;
						DisplayMonitorMode* mode_to_check = NULL;
						GeeLinkedList* _tmp43_;
						gint _tmp44_;
						gpointer _tmp45_;
						gboolean mode_found = FALSE;
						gboolean _tmp72_;
						_tmp40_ = _mode_to_check_index;
						_mode_to_check_index = _tmp40_ + 1;
						_tmp41_ = _mode_to_check_index;
						_tmp42_ = _mode_to_check_size;
						if (!(_tmp41_ < _tmp42_)) {
							break;
						}
						_tmp43_ = _mode_to_check_list;
						_tmp44_ = _mode_to_check_index;
						_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, _tmp44_);
						mode_to_check = (DisplayMonitorMode*) _tmp45_;
						mode_found = FALSE;
						{
							GeeLinkedList* _monitor_mode_list = NULL;
							DisplayMonitor* _tmp46_;
							GeeLinkedList* _tmp47_;
							GeeLinkedList* _tmp48_;
							GeeLinkedList* _tmp49_;
							gint _monitor_mode_size = 0;
							GeeLinkedList* _tmp50_;
							gint _tmp51_;
							gint _tmp52_;
							gint _monitor_mode_index = 0;
							_tmp46_ = monitor;
							_tmp47_ = display_monitor_get_modes (_tmp46_);
							_tmp48_ = _tmp47_;
							_tmp49_ = _g_object_ref0 (_tmp48_);
							_monitor_mode_list = _tmp49_;
							_tmp50_ = _monitor_mode_list;
							_tmp51_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp50_);
							_tmp52_ = _tmp51_;
							_monitor_mode_size = _tmp52_;
							_monitor_mode_index = -1;
							while (TRUE) {
								gint _tmp53_;
								gint _tmp54_;
								gint _tmp55_;
								DisplayMonitorMode* monitor_mode = NULL;
								GeeLinkedList* _tmp56_;
								gint _tmp57_;
								gpointer _tmp58_;
								gboolean _tmp59_ = FALSE;
								DisplayMonitorMode* _tmp60_;
								gint _tmp61_;
								gint _tmp62_;
								DisplayMonitorMode* _tmp63_;
								gint _tmp64_;
								gint _tmp65_;
								_tmp53_ = _monitor_mode_index;
								_monitor_mode_index = _tmp53_ + 1;
								_tmp54_ = _monitor_mode_index;
								_tmp55_ = _monitor_mode_size;
								if (!(_tmp54_ < _tmp55_)) {
									break;
								}
								_tmp56_ = _monitor_mode_list;
								_tmp57_ = _monitor_mode_index;
								_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) _tmp56_, _tmp57_);
								monitor_mode = (DisplayMonitorMode*) _tmp58_;
								_tmp60_ = mode_to_check;
								_tmp61_ = display_monitor_mode_get_width (_tmp60_);
								_tmp62_ = _tmp61_;
								_tmp63_ = monitor_mode;
								_tmp64_ = display_monitor_mode_get_width (_tmp63_);
								_tmp65_ = _tmp64_;
								if (_tmp62_ == _tmp65_) {
									DisplayMonitorMode* _tmp66_;
									gint _tmp67_;
									gint _tmp68_;
									DisplayMonitorMode* _tmp69_;
									gint _tmp70_;
									gint _tmp71_;
									_tmp66_ = mode_to_check;
									_tmp67_ = display_monitor_mode_get_height (_tmp66_);
									_tmp68_ = _tmp67_;
									_tmp69_ = monitor_mode;
									_tmp70_ = display_monitor_mode_get_height (_tmp69_);
									_tmp71_ = _tmp70_;
									_tmp59_ = _tmp68_ == _tmp71_;
								} else {
									_tmp59_ = FALSE;
								}
								if (_tmp59_) {
									mode_found = TRUE;
									_g_object_unref0 (monitor_mode);
									break;
								}
								_g_object_unref0 (monitor_mode);
							}
							_g_object_unref0 (_monitor_mode_list);
						}
						_tmp72_ = mode_found;
						if (_tmp72_ == FALSE) {
							GeeLinkedList* _tmp73_;
							DisplayMonitorMode* _tmp74_;
							_tmp73_ = to_remove;
							_tmp74_ = mode_to_check;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp73_, _tmp74_);
						}
						_g_object_unref0 (mode_to_check);
					}
					_g_object_unref0 (_mode_to_check_list);
				}
				_tmp75_ = common_modes;
				_tmp76_ = to_remove;
				gee_collection_remove_all ((GeeCollection*) _tmp75_, (GeeCollection*) _tmp76_);
				_g_object_unref0 (to_remove);
			}
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = common_modes;
	return result;
}


gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors) {
	gdouble result = 0.0;
	gdouble min_scale = 0.0;
	g_return_val_if_fail (monitors != NULL, 0.0);
	min_scale = DBL_MAX;
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
		_tmp0_ = monitors;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_monitor_list = _tmp1_;
		_tmp2_ = _monitor_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_monitor_size = _tmp4_;
		_monitor_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			gdouble _tmp11_;
			DisplayMonitor* _tmp12_;
			gdouble _tmp13_;
			gdouble _tmp14_;
			_tmp5_ = _monitor_index;
			_monitor_index = _tmp5_ + 1;
			_tmp6_ = _monitor_index;
			_tmp7_ = _monitor_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _monitor_list;
			_tmp9_ = _monitor_index;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
			monitor = (DisplayMonitor*) _tmp10_;
			_tmp11_ = min_scale;
			_tmp12_ = monitor;
			_tmp13_ = display_monitor_get_max_scale (_tmp12_);
			_tmp14_ = MIN (_tmp11_, _tmp13_);
			min_scale = _tmp14_;
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_list);
	}
	result = min_scale;
	return result;
}



